;=====================================================================
; I wrote this a couple years ago for a friend.  It is a little crude
; but it did the job he wanted.  If you can use it, fine.  If it does
; not do what you need, let me know and if it's something I can fix
; without too much trouble, I'll be gald to help.  -Ray Templin
;=====================================================================
; infield.sc will copy the contants of a field in one table into the
; field of another table, provided the fields are the same type.
;=====================================================================

; VARs: table_source, table_target, fld_source, fld_stype, fld_target,
;       fld_ttype, allrecs(), count, recnum, fldtype

CLEAR
SHOWFILES NOEXT
"*.db"
"Pick the source table"
TO table_source
IF table_source="none" OR NOT retval THEN QUIT
ENDIF
Esc
EXECUTE "Menu {Tools} {Info} {Structure} {"+table_source+"}"
ClearImage
WHILE (True)
  VIEW "struct"
  Right
  WAIT TABLE
  PROMPT "Source table: "+table_source+".  Chose any field type.","Press [Enter] to select the field at the cursor, [Esc] to quit."
  UNTIL "Enter", "Esc"
  SWITCH
    CASE retval="Esc": DELETE "struct" QUIT
    CASE retval="Enter":
      fld_source=[Field Name] fld_stype=[Field Type] QUITLOOP
    OTHERWISE: BEEP
  ENDSWITCH
ENDWHILE
ClearImage
DELETE "struct"
CLEAR
fldtype=SUBSTR(fld_stype,1,1)
SWITCH
  CASE fldtype="A":fldtype="alpha"
  CASE fldtype="D":fldtype="date"
  CASE fldtype="$":fldtype="dollars"
  CASE fldtype="N":fldtype="number"
  CASE fldtype="S":fldtype="integer"
ENDSWITCH
SHOWFILES NOEXT
"*.db"
"Pick the target table"
TO table_target
IF table_target="none" OR NOT retval THEN QUIT
ENDIF
Esc
EXECUTE "Menu {Tools} {Info} {Structure} {"+table_target+"}"
ClearImage
WHILE (True)
  VIEW "struct"
  Right
  WAIT TABLE
  PROMPT "Target table: "+table_target+".  Field must be type "+fldtype+".","Press [Enter] to select the field at the cursor, [Esc] to quit."
  UNTIL "Enter", "Esc"
  SWITCH
    CASE retval="Esc":DELETE "struct" QUIT
    CASE retval="Enter":
      fld_target=[Field Name] fld_ttype=[Field Type] QUITLOOP
    OTHERWISE: BEEP
  ENDSWITCH
ENDWHILE
DELETE "struct"
ClearImage
CLEAR
@ 11, 28 ??"Just a moment, please"
IF SUBSTR(fld_stype,1,1)<>SUBSTR(fld_ttype,1,1) THEN
  CLEAR CURSOR OFF
  @10,24??"The fields are not compatable"
  @12,28??"Press any key to quit"
  WHILE CHARWAITING()
    key=GETCHAR()
  ENDWHILE
  key=GETCHAR()
  QUIT
ENDIF
IF fldtype="alpha" THEN
  count=NUMVAL(SUBSTR(fld_stype,2,3))
  recnum=NUMVAL(SUBSTR(fld_ttype,2,3))
  IF recnum<count THEN CLEAR count=count-recnum
    WHILE (True)
      @ 11,11 ??"The source field: "+fld_source+", is larger than the target field:"
      @ 12,11 ??fld_target+".  You will lose "+STRVAL(count)+" characters if you continue."
      SHOWMENU
        "No" :"Do you want to continue?",
        "Yes" :"Do you want to continue?"
      TO choice
      SWITCH
        CASE choice="Yes": QUITLOOP
        CASE choice="No": QUIT
        OTHERWISE: LOOP
      ENDSWITCH
    ENDWHILE
  ENDIF
ENDIF
CLEAR @ 11,28??"Just a moment, please"
recnum=NRECORDS(table_source)
ARRAY allrecs[recnum]
VIEW table_source
MOVETO FIELD fld_source
FOR count FROM 1 TO recnum
  MOVETO RECORD count
  allrecs[count]=[]
ENDFOR
ClearImage
EDIT table_target
MOVETO FIELD fld_target
IF []<>"" THEN CLEAR
  WHILE (True)
    @ 11,10 ??"There is data in field: "+fld_target+", of table: "+table_target
      SHOWMENU
        "No" :"Do you want to overwirte the data?",
        "Yes" :"Do you want to overwrite the data?"
      TO choice
      SWITCH
        CASE choice="Yes": QUITLOOP
        CASE choice="No":
          CANCELEDIT ClearImage CLEAR QUIT
        OTHERWISE: LOOP
      ENDSWITCH
  ENDWHILE
ENDIF
CLEAR @ 11,28??"Just a moment, please"
FOR count FROM 1 TO recnum
  []=allrecs[count]
  Down
ENDFOR
Do_It!
QUIT
